<?php
	#enter location for SOX (default is fine)
	$soxloc = "sox.exe";
	#enter wave audio device to record on
	$wad = 2;
	#enter sample rate for audio recording WAVs (doesn't apply to MP3)
	$srate = 22050;
	#file extension (default '.mp3')
	$sndext = ".mp3";
	#enter full path to sdrsharptrunking.log
	$trunkloc = "S:/httpd/UniTrunker/sdrsharptrunking.log";
	#enter timezone (https://php.net/manual/en/timezones.php)
	date_default_timezone_set('America/New_York');
	#enter path to save files (YYYY/MM/DD will be created inside this, be sure to keep pathnames short)
	$savedir = "../scn/calls/";
	#enter format for saving folders
	#SEE line 123
	#enter format for saving files(default recommended)
	#SEE line 126
	#enter year to make folders until(this script will make folders for each day, month and year until the year below)
	$fldryr = 2020;
	#Sleep time, higher number = higher chance of cut off calls, default 20ms, 0.020
	$sleeptime = 0;
	
	function readfil($trunkloc){
		$file = file_get_contents($trunkloc);
		$fileline = explode("\n",$file);
		#preliminary explode
		#may throw errors if file is being written
		@list($action,$receiver,$frequency) = explode("	",$fileline[1]);
		if ($action == 'Park'){
			$targetid = 'Parked';
			return array($targetid);
		}elseif ($action == 'Listen'){
			#Get full info
			list($action,$receiver,$frequency,$targetid,$targetlabel,$sourceid,$sourcelabel) = explode("	",$fileline[1]);
			return array($targetid,$targetlabel,$sourceid,$sourcelabel,$action);
		}
	}
	function killsox(){
		#hacked no wait exec()
		pclose(popen("taskkill /F /IM sox.exe /T","r"));
		#clear single line screen
		echo "\n";
	}
	function sanitizefs($filename){
		$invalidchars = array(">","<",":",'"',"/","\\","|","?","*");
		return str_replace($invalidchars,"",$filename);
	}
	#FUNCTIONS DONE
	
	#INITIALIZE CODE
	echo "LOG RECORDER by Tylerwatt12. Version 3.2.1\n";
	echo "Making directories, this may take a few moments\n";
	echo "Errors that SOX was not found are OKAY\n";
	sleep(4);
	#replace forwardslash with backslash
	$savedirfs = str_replace('/','\\',$savedir);
	#make every dir until specified date
	$m = 01;
	$d = 01;
	$y = date("Y");
	while ($y < $fldryr + 1){
		while ($m < 13){
			while ($d < 32){
				$file = $savedir.$y."/".sprintf("%02d",$m)."/".sprintf("%02d",$d);
				#If dir already exists
				if (is_dir($file)){
					#do nothing
				}else{
					#make directory
					exec('mkdir '.$savedirfs.$y."\\".sprintf("%02d",$m)."\\".sprintf("%02d",$d));
				}
				#increment date
				$d++;
			}
			#after 31 days, reset counter
			$d = 01;
			#increment month
			$m++;
		}
		#after 12 months, reset counter
		$m = 01;
		#increment year
		$y++;
	}
	#kill any remaining sox instances
	killsox();
	#purge screen buffer
	echo "\n\n\n";
	#folder creation done
	echo "Done! Waiting for first call\n";
	#Starting variable outside loop
	$oldtargetid = readfil($trunkloc);
	#X will always = 1 for the loop to continue
	$x = 1;
	#START LOOP
	while ($x == 1) {
		#creating variable to compare to oldtargetid
		$newtargetid = readfil($trunkloc);
		if ($newtargetid[0] != $oldtargetid[0]){
			#set old target ID for the next loop around
			$oldtargetid = $newtargetid;
			#IF parked
			if ($newtargetid[0] == 'Parked'){
				killsox();
				echo "\n\nWaiting for call\n\n";
			}elseif ($newtargetid[4] == 'Listen'){
			#IF TG gets changed
				#sanitize strings to be windows FS compatible
				#these strings get sent to the command processor
				$finalTGID = sanitizefs($newtargetid[0]);
				$finalTGName = sanitizefs($newtargetid[1]);
				$finalRID = sanitizefs($newtargetid[2]);
				$finalRName = sanitizefs($newtargetid[3]);
				#kill previous sox instances
				killsox();
				echo "\nTalkgroup: ".$finalTGID;
				echo "\nName     : ".$finalTGName;
				echo "\nRadioID  : ".$finalRID;
				echo "\nRID name : ".$finalRName;
				#set folder format
				$fldrfmt = date("Y")."/".date("m")."/".date("d")."/";
				#launch SOX, write file
				#sends the command to cmd, start minimized, sox.exe -t waveaudio 1 -r22050 -c1 "X:/YOURDIR/MM/DD/UNIXTIME_TGID_TGNAME_RID_RIDNAME.mp3"
				pclose(popen("start /min ".$soxloc." -t waveaudio ".$wad." -r".$srate." -c1 \"".$savedir.$fldrfmt.time()."_".$finalTGID."_".$finalTGName."_".$finalRID."_".$finalRName.$sndext."\"","r"));		
			}
		}else{
			#No change, this loops every time the file is polled
		}
		#slows down polling, remove me in production
		usleep(150000);
	}
?>